BookFusion.Search = (() => {
  let highlights = []

  function setTerms (terms) {
    highlights = terms.map(({ localId, startOffset, endOffset }) =>
      BookFusion.Highlights.highlight(localId, startOffset, endOffset, 'bf-search-term')
    )
  }

  function setTermsAndRemovePrevious (terms) {
    removeAllTerms()

    highlights = []
    terms.forEach(({ localId, startOffset, endOffset }) => {
        const highlight = BookFusion.Highlights.highlight(localId, startOffset, endOffset, 'bf-search-term')
        if (highlight != null) {
           highlights.push(highlight)
        }
      }
    )
  }

  function removeAllTerms () {
    highlights.forEach(term => {
      BookFusion.Highlights.unhighlight(term)
    })
    highlights = []
  }

  return {
    setTerms,
    setTermsAndRemovePrevious,
    removeAllTerms
   }
})()