BookFusion.Transformation = (() => {
  function transformRectFromNative(rect) {
    var pixelRatio = window.devicePixelRatio;
    return {
      x: rect.x / pixelRatio,
      y: rect.y / pixelRatio,
      width: rect.width / pixelRatio,
      height: rect.height / pixelRatio
    }
  }

  function transformRectToNative(rect) {
    var pixelRatio = window.devicePixelRatio;
    return {
      x: rect.x * pixelRatio,
      y: rect.y * pixelRatio,
      width: rect.width * pixelRatio,
      height: rect.height * pixelRatio
    }
  }

  function convertToWebViewFrame (rect) {
    // x and y are undefined on iOS 10
    const x = window.getComputedStyle(document.body).direction === 'rtl'
      ? clientContentSize.width - (rect.right + window.scrollX)
      : rect.left + window.scrollX
    const y = rect.top
    const width = rect.width
    const height = rect.height
    return { x, y, width, height }
  }

  function convertToWebViewFrameNative (rect) {
    var pixelRatio = window.devicePixelRatio;
    // x and y are undefined on iOS 10
    const x = window.getComputedStyle(document.body).direction === 'rtl'
      ? (clientContentSize.width - (rect.right + window.scrollX)) * pixelRatio
      : (rect.left + window.scrollX) * pixelRatio
    const y = rect.top * pixelRatio
    const width = rect.width * pixelRatio
    const height = rect.height * pixelRatio
    return { x, y, width, height }
  }

  return {
    transformRectFromNative,
    transformRectToNative,
    convertToWebViewFrame,
    convertToWebViewFrameNative
  }
})()